SystemOrganization addCategory: #FingerTree!

AlgebraicDataType subclass: #Digit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FingerTree'!

Digit subclass: #Four
	instanceVariableNames: 'one two three four'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FingerTree'!

!Four class methodsFor: 'instance creation' stamp: 'fbs 8/2/2011 22:03'!
one: one two: two three: three four: four
	^ self new one: one two: two three: three four: four.! !

!Four methodsFor: 'accessing' stamp: 'fbs 8/2/2011 22:03'!
four
	^ four.! !

!Four methodsFor: 'accessing' stamp: 'fbs 8/2/2011 22:03'!
one
	^ one.! !

!Four methodsFor: 'private' stamp: 'fbs 8/2/2011 22:03'!
one: aOne two: aTwo three: aThree four: aFour
	one := aOne.
	two := aTwo.
	three := aThree.
	four := aFour.! !

!Four methodsFor: 'accessing' stamp: 'fbs 8/2/2011 22:03'!
three
	^ three.! !

!Four methodsFor: 'accessing' stamp: 'fbs 8/2/2011 22:03'!
two
	^ two.! !

Digit subclass: #One
	instanceVariableNames: 'one'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FingerTree'!

!One class methodsFor: 'instance creation' stamp: 'fbs 8/2/2011 22:03'!
one: one
	^ self new one: one.! !

!One methodsFor: 'accessing' stamp: 'fbs 8/2/2011 22:03'!
one
	^ one.! !

!One methodsFor: 'private' stamp: 'fbs 8/2/2011 22:03'!
one: aOne
	one := aOne.! !

Digit subclass: #Three
	instanceVariableNames: 'one two three'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FingerTree'!

!Three class methodsFor: 'instance creation' stamp: 'fbs 8/2/2011 22:03'!
one: one two: two three: three
	^ self new one: one two: two three: three.! !

!Three methodsFor: 'accessing' stamp: 'fbs 8/2/2011 22:03'!
one
	^ one.! !

!Three methodsFor: 'private' stamp: 'fbs 8/2/2011 22:03'!
one: aOne two: aTwo three: aThree
	one := aOne.
	two := aTwo.
	three := aThree.! !

!Three methodsFor: 'accessing' stamp: 'fbs 8/2/2011 22:03'!
three
	^ three.! !

!Three methodsFor: 'accessing' stamp: 'fbs 8/2/2011 22:03'!
two
	^ two.! !

Digit subclass: #Two
	instanceVariableNames: 'one two'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FingerTree'!

!Two class methodsFor: 'instance creation' stamp: 'fbs 8/2/2011 22:03'!
one: one two: two
	^ self new one: one two: two.! !

!Two methodsFor: 'accessing' stamp: 'fbs 8/2/2011 22:03'!
one
	^ one.! !

!Two methodsFor: 'private' stamp: 'fbs 8/2/2011 22:03'!
one: aOne two: aTwo
	one := aOne.
	two := aTwo.! !

!Two methodsFor: 'accessing' stamp: 'fbs 8/2/2011 22:03'!
two
	^ two.! !

AlgebraicDataType subclass: #Node
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FingerTree'!

!Node class methodsFor: 'instance creation' stamp: 'fbs 7/22/2011 17:56'!
apply: aCollection
	self assertCorrectSize: aCollection.
	self assertCorrectTag: aCollection.
	^ self left: (Tree apply: aCollection second) right: (Tree apply: aCollection third).! !

!Node class methodsFor: 'instance creation' stamp: 'fbs 5/22/2011 20:21'!
left: aLeftObject 
	^ self left: aLeftObject right: Tree empty.! !

!Node class methodsFor: 'instance creation' stamp: 'fbs 5/22/2011 20:21'!
left: aLeftObject right: aRightObject
	^ self new left: aLeftObject right: aRightObject.! !

!Node class methodsFor: 'instance creation' stamp: 'fbs 5/22/2011 20:21'!
right: aRightObject
	^ self left: Tree empty right: aRightObject.! !

!Node methodsFor: 'accessing' stamp: 'fbs 5/22/2011 20:22'!
left
	^ left.! !

!Node methodsFor: 'private' stamp: 'fbs 5/22/2011 20:22'!
left: aLeftObject right: aRightObject
	left := aLeftObject.
	right := aRightObject.! !

!Node methodsFor: 'accessing' stamp: 'fbs 5/22/2011 20:22'!
right
	^ right.! !

!Node methodsFor: 'destructuring' stamp: 'fbs 7/22/2011 18:25'!
unapply
	^ {#Node. left. right.}! !

Node subclass: #Node2
	instanceVariableNames: 'measureone two'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FingerTree'!

!Node2 class methodsFor: 'instance creation' stamp: 'fbs 8/2/2011 22:03'!
measureone: measureone two: two
	^ self new measureone: measureone two: two.! !

!Node2 methodsFor: 'accessing' stamp: 'fbs 8/2/2011 22:03'!
measureone
	^ measureone.! !

!Node2 methodsFor: 'private' stamp: 'fbs 8/2/2011 22:03'!
measureone: aMeasureone two: aTwo
	measureone := aMeasureone.
	two := aTwo.! !

!Node2 methodsFor: 'accessing' stamp: 'fbs 8/2/2011 22:03'!
two
	^ two.! !

Node subclass: #Node3
	instanceVariableNames: 'measure one two thre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FingerTree'!

!Node3 class methodsFor: 'as yet unclassified' stamp: 'fbs 8/2/2011 22:03'!
measure: measure one: one two: two thre: thre
	^ self new measure: measure one: one two: two thre: thre.! !

!Node3 methodsFor: 'accessing' stamp: 'fbs 8/2/2011 22:03'!
measure
	^ measure.! !

!Node3 methodsFor: 'as yet unclassified' stamp: 'fbs 8/2/2011 22:03'!
measure: aMeasure one: aOne two: aTwo thre: aThre
	measure := aMeasure.
	one := aOne.
	two := aTwo.
	thre := aThre.! !

!Node3 methodsFor: 'accessing' stamp: 'fbs 8/2/2011 22:03'!
one
	^ one.! !

!Node3 methodsFor: 'accessing' stamp: 'fbs 8/2/2011 22:03'!
thre
	^ thre.! !

!Node3 methodsFor: 'accessing' stamp: 'fbs 8/2/2011 22:03'!
two
	^ two.! !
